<?php
	// updated by JATUPORN 2559-07-05, update infopath= by WIBOON 2559-08-11
	// updated by WIBOON 2559-10-17
	// updated by WIBOON 2559-11-02 for ldap.example.com

	//
	// Default Config
	// Server ldap type : "activedirectory" or "openldap"
	//
	// --- Example : OpenLdap example.com
	$servertype = "openldap";
	$server = array("ldap.example.com");

	// --- Example : Microsoft AD ---
	// $servertype = "activedirectory";
	//$server = array("xx1.yy.ac.th","xx2.yy.ac.th","xx3.yy.ac.th");


	//	
	//Logging User Information
	//

	$userinfo = true;
	// file owner must be freerad
	$infopath = "/var/www/ticker/userinfo.txt";

	// --- Example : OpenLdap example.com
	$attribute = array("displayname","mail");

	// --- Example : Microsoft AD ---
	//$attribute = array("attr1","attr2","attr3","attr4","attr5","attr6","attr7","attr8","attr9","attr10","attr11");

	
	//
	// Base OU for search all user
	// Note : $basedn can support multiple ou with array list etc. array(ou1,ou2,ou3)
	//
	
	// --- Example : OpenLdap example.com
	$basedn = "dc=example,dc=com";
	$domain = "example.com";
	
	// --- Example : Microsoft AD domain
	//$basedn = "dc=yy,dc=ac,dc=th";
	//$domain = "yy.ac.th";
	

	// Get Username & Password from linux command line
	$username=$argv[1];
	$password=$argv[2];
	
	// If have third argument -> Filter OU with specific IP (Define user group for access)
	if(isset($argv[3])){
                if($argv[3]=="127.0.0.1"){
			// --- Example : OpenLdap People Only ---
			//$searchdn = array("ou=staffs,ou=groups,dc=example,dc=com");
			// --- Example : OpenLdap All ---
			$searchdn = array("dc=example,dc=com");
			
			// --- Example : Microsoft AD Students Only --
			//$searchdn = array("ou=Student,dc=yy,dc=ac,dc=th");
			// --- Example : Microsoft AD Staffs Only --
			//$searchdn = array("ou=Staff,dc=yy,dc=ac,dc=th");
			// --- Example : Microsoft AD Staffs and Students --
			//$searchdn = array("ou=Staff,dc=yy,dc=ac,dc=th","ou=Student,dc=yy,dc=ac,dc=th");
			// --- Example : Microsoft AD All --
			//$searchdn = array("dc=yy,dc=ac,dc=th");
		}else{
			$searchdn[0] = $basedn;
		}
        }else{
		$searchdn[0] = $basedn;
	}
	
	function authenticate($servertype,$server,$basedn,$searchdn,$domain,$username,$password){
		// Define boolean default value
		$auth_status = false;
		$ou_check = false;
		
		$i=0;
		if(trim($password)<>""){
			while(($i<count($server))&&($auth_status==false)){
				$ldap_connect = true;
				$bind_dn = true;
				$bind_info = true;
				// Ldap connect
				$ldap = @ldap_connect("ldaps://".$server[$i]) or $ldap_connect = false;
				ldap_set_option($ldap, LDAP_OPT_REFERRALS, 0);
				ldap_set_option($ldap, LDAP_OPT_PROTOCOL_VERSION, 3);
				
				if($ldap_connect == true){
					// Anonymous bind
					$ldapbind = @ldap_bind($ldap) or $bind_dn = false;
					if($bind_dn == true){
						// Search DN
						if($servertype=="openldap"){
							$sd=ldap_search($ldap, $basedn, "uid=".$username, array("dn"));
						}else{
							$ldapbind = @ldap_bind($ldap, $username."@".$domain, $password) or $bind_info = false;
							$sd=ldap_search($ldap, $basedn, "PName=".$username."@".$domain,array("dn"));
							//Special for your AD search
							$sdad=ldap_search($ldap, $basedn, "PName=".$username."@mail.yy.ac.th",array("dn"));
							//End Special for your AD search
						}	
						$dninfo = ldap_get_entries($ldap,$sd);
						//Special for your AD search
						if($servertype<>"openldap"){
							if(!isset($dninfo[0]['dn'])){
								unset($dninfo);
								$dninfo = ldap_get_entries($ldap,$sdad);
							}
						}
						//End Special for your AD search
						// User found in ldap account
						if(isset($dninfo[0]['dn'])){
							$dn = $dninfo[0]['dn'];
							// Check condition filter OU with specific IP
							// Authentication Bind with filter OU
							if($servertype=="openldap"){
								$ldapbind = @ldap_bind($ldap,$dn,$password) or $bind_info = false;
							}
							if($bind_info == true){
								$j=0;
								while(($j<count($searchdn))&&($ou_check==false)){
									if($servertype=="openldap"){
										$sr=@ldap_search($ldap, $searchdn[$j], "uid=".$username, array("dn"));
									}else{
										$sr=@ldap_search($ldap, $searchdn[$j], "(&(objectClass=user)(objectCategory=person)(samaccountname=".$username."))",array("dn"));
									}
									$info = @ldap_get_entries($ldap, $sr);
									if(isset($info[0]["dn"])){
										$ou_check = true;
									}else{
										$ou_check = false;
									}
									unset($info);
									$j++;
								}
								if($ou_check==true){
									$auth_status = true;
								}else{
									$auth_status = false;
								}
							}
						}
						unset($dninfo);
					}
				}
				ldap_close($ldap);
				$i++;
			}
		}
		return $auth_status;
	}
	
	function userinfo($servertype,$server,$basedn,$searchdn,$domain,$username,$password,$infopath,$attribute){
		$auth_check = false;
		$infofile = fopen($infopath,"a+");
        	$i=0;
        	while(($i<count($server))&&($auth_check==false)){
			$ldap_connect = true;
			$bind_dn = true;
			$bind_info = true;
			// Ldap connect
			$ldap = @ldap_connect("ldaps://".$server[$i]) or $ldap_connect = false;
			ldap_set_option($ldap, LDAP_OPT_REFERRALS, 0);
			ldap_set_option($ldap, LDAP_OPT_PROTOCOL_VERSION, 3);
			
			if($ldap_connect == true){
				// Anonymous bind
				$ldapbind = @ldap_bind($ldap) or $bind_dn = false;
				if($bind_dn == true){
					// Search DN
					if($servertype=="openldap"){
						$sd=ldap_search($ldap, $basedn, "uid=".$username, array("dn"));
					}else{
						$ldapbind = @ldap_bind($ldap, $username."@".$domain, $password) or $bind_info = false;
						$sd=ldap_search($ldap, $basedn, "PName=".$username."@".$domain,array("dn"));
						//Special for your AD search
						$sdad=ldap_search($ldap, $basedn, "PName=".$username."@mail.yy.ac.th",array("dn"));
						//End Special for your AD search
					}	
					$dninfo = ldap_get_entries($ldap,$sd);
					//Special for your AD search
					if($servertype<>"openldap"){
						if(!isset($dninfo[0]['dn'])){
							unset($dninfo);
							$dninfo = ldap_get_entries($ldap,$sdad);
						}
					}
					//End Special for your AD search
					//User found in ldap account
					if(isset($dninfo[0]['dn'])){
						$dn = $dninfo[0]['dn'];
						// Check condition filter OU with specific IP
						// Authentication Bind with filter OU
						if($servertype=="openldap"){
							$ldapbind = @ldap_bind($ldap,$dn,$password) or $bind_info = false;
						}
						if($bind_info == true){
							$j=0;
							while(($j<count($searchdn))&&($auth_check==false)){
								if($servertype=="openldap"){
									$sr=@ldap_search($ldap, $searchdn[$j], "uid=".$username, $attribute);
								}else{
									$sr=@ldap_search($ldap, $searchdn[$j], "(&(objectClass=user)(objectCategory=person)(samaccountname=".$username."))",$attribute);
								}
								$info = @ldap_get_entries($ldap, $sr);
								$detaillog = "";
								$first = true;
								for($k=0;$k<count($attribute);$k++){
									if(isset($info[0][$attribute[$k]][0])){
										if($first==true){
											$detaillog .= $info[0][$attribute[$k]][0];
											$first = false;
										}else{
											$detaillog .= ",".$info[0][$attribute[$k]][0];
										}
										$auth_check = true;
									}else{
										if($first==true){
                                                                                        $detaillog .= "null";
                                                                                        $first = false;
                                                                                }else{
                                                                                        $detaillog .= ",null";
                                                                                }
									}
								}	
								fwrite($infofile,$detaillog."\n");
								unset($info);
								$j++;
							}
						}
					}
					unset($dninfo);
				}
			}
			ldap_close($ldap);
			$i++;
			
		}
		
		fclose($infofile);
		
	}

	// Call authenticate function
	$authen = authenticate($servertype,$server,$basedn,$searchdn,$domain,$username,$password);
	if($authen==true){
		if($userinfo==true){
			userinfo($servertype,$server,$basedn,$searchdn,$domain,$username,$password,$infopath,$attribute);
		}
		echo "true";
	}else{
		echo "false";
	}
?>
