#!/bin/bash

#updated: wiboon 2-11-2559

#Begin Checking argument trap.
exitusage() 
{
  echo "usage: bash $0 whattocheck"
  echo "Example: bash $0 php-ldap"
  echo "     or: bash $0 webservice"
  exit 
}

checkinput() 
{ 
  echo $1 | grep -Eq '^(\+|-)?[0-9]+$'
  return $?
}

if [ "$1" = "--help" ] ; then
  exitusage
fi
if [ -z "$1" ] ; then
  exitusage
else
  whattocheck=$1
fi
#if [ "${whattocheck}" != "php-ldap" ] ; then
#   if [ "${whattocheck}" != "webservice" ] ; then
#      exitusage
#   fi
#fi
if [ ! "${whattocheck}" = "php-ldap" -a ! "${whattocheck}" = "webservice" ] ; then
  exitusage
fi
#End Checking argument trap.

#if no Checking argument trap block above, you must
# uncomment if test psu passport login (psu.ac.th) with ldap
#whattocheck="php-ldap"
# uncomment if test psu passport login (psu.ac.th) with web service
#whattocheck="webservice"

if [ "${whattocheck}" = "php-ldap" ] ; then
   moduleready=$(dpkg -l | grep -i "LDAP module for php")
   if [ -z "${moduleready}" ] ; then
     echo "Please install php-ldap (LDAP module for php)"
     echo "ubuntu: sudo apt-get install php-ldap"
     exit 1
   fi
fi

# For testing on command line purpose only
# accept key type 
echo -n "username: (without @domain) "
read USER
echo -n "password: "
read -s PASSWORD
echo
if [ "${whattocheck}" = "php-ldap" ] ; then
   filename=$(grep '$infopath =' check-ad-ldap.php | awk -F\" '{print $2}')
   owner=$(grep 'freeradius' /etc/passwd | awk -F: '{print $1}')
   if [ -f ${filename} ] ; then
        checkowner=$(ls -l ${filename} | awk '{print $3}')
        if [ ${checkowner} != "${owner}" ] ; then
           chown ${owner} ${filename}
        fi
   else
        dn=$(dirname ${filename})
        if [ ! -d "${dn}" ] ; then
           mkdir -p ${dn}
        fi
        touch ${filename}
        chown ${owner} ${filename}
   fi
   /usr/bin/php /etc/freeradius/check-ad-ldap.php "${USER}" "${PASSWORD}" 127.0.0.1
else
   /usr/bin/php /etc/freeradius/soap-authen.php "${USER}" "${PASSWORD}"
fi
echo
echo 'If you get "true", it means username and passwoord are right.'
echo
